//*****************************************************************************
//*
//*
//*		GetWanIp
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include	"StdAfx.h"
#include	"HttpClient.h"

const char *pWhoIamHosts[]=
	{
	"www.ip-ermitteln.de/",
	"www.your-connect.ch/ip-browser-herausfinden.asp",
	"www.dslreports.com/whois",
	"www.bolege.de/whoiam/",
	"www.meine-ip.de.vu/",
	"www.wieistmeineip.de/",
	"www.router-forum.de/ip.php",
	"www.ipnummer.de/z/ippopz.pl",
	"www.schwarzl.at/ipcheck.html",
	"meine-ip-adresse.web-extras.de/",
	"ipnr.rehbein.net/",
	"www.epocwelt.de/mysql/ip.php3",
	"www.adtronik.de/ip.shtm",
	"elib.suub.uni-bremen.de/cgi-bin/ipcheck",
	"www.gottfriedditz.de/ditz/cgi-bin/env_info1.pl?info=ip",
	"meineipadresse.de/",
	"www.sicovend.ch/_iu_write/ip.php",
	"www.deine-ip.de/",
	"www.aida.uni-hannover.de/AIDA/20~Institut/Computer/Eigene_IP-Adresse/",
	"ip.go-hjn.de/",
	"www.ipadresse.net/",
	"www2.wu-wien.ac.at/ip.php",
	"www.simbuerger.com/information/ip.php",
	"www.myip.dk/",
	"www.an1world.net/ip/ip.htm",
	"meineipadresse.de/html/micro.html",
	"www.pracht.biz/ip-adresse.php",
	"www.solnet.ch/support/faq/answer/54.html",
	"www.ip.web2x.de/",
	"ip.topster.de/",
	"www.oe9.oevsv.at/ip/",
	"ip.mediagonal.net/",
	"www.corsys.net/myip.asp",
	"support.net-lab.net/cgi-bin/show_ip.cgi",
	"www.univie.ac.at/Datennetz/cgi-bin/xy.cgi",
	"take2.homeip.net/sonstiges/ip.php",
	"www.whatismyip.com/",
	"www.lawrencegoetz.com/programs/ipinfo/",
	"checkip.dyndns.org/",
	"www.showmyip.com/  (de/)",
	"www.ipaddressworld.com/",
	"www.ipchicken.com/",
	"privacy.net/",
	"www.edpsciences.org/htbin/ipaddress",
	"megawx.aws.com/support/faq/software/ip.asp",
	"www.myipaddress.com/",
	"www2.simflex.com/ip.shtml",
	"www.sbbs.com/internet/myipaddress.html",
	"www.whatsmyip.org/",
	"www.haxial.com/whatismyipaddress/",
	"www.rootsecure.net/?p=your_ip",
	};

#define 	MAX_HOSTS	(sizeof(pWhoIamHosts)/sizeof(pWhoIamHosts[0]))

//*****************************************************************************
//*
//*		GetWanIp
//*
//*****************************************************************************
//	Erginbt die IP-Addresse mir der, der Computer nach ausen ins Web sichtbar ist
//	iHostsMin	: Ist die Zahl der Hosts von denen die IP-Addresse
//				  gltig geliefert werden muss.
//	ulTimeout	: Ist die Zeit in Sekunden die eine Anfrage gltig bleibt.
//	Ergibt einen Zeiger auf die IP Adresse.
const char *GetWanIp(int iHostsMin=2,unsigned long ulTimeout=60*10)
{
static char     cCurrentIp[20];
static time_t	iCurrentTime=0;
CHttpClient		sConnection;
const char     *pHtmlData;
const char     *pFilename;
char			cHostname[128];
char			cHostIp[8][20];
int				iHostNr[MAX_HOSTS];
int				iCount,iPos,iLen,iNr,i,j;
int				iNext,iLast,iFound,iOkCount=0;



												// Ist die letzte IP noch aktuell
	if(iCurrentTime && iCurrentTime+(int)ulTimeout>time(0))
		{
		return cCurrentIp;
		}

	if(iHostsMin<0)iHostsMin=1;
	if(iHostsMin>8)iHostsMin=8;

	srand(time(0));

	for(iCount=0;iCount<MAX_HOSTS;iCount++)
		{
		iNr=rand()%MAX_HOSTS;					// Zufllig eine Server auswhlen
		if(iCount==0)iNr=0;

		for(i=0;i<iCount;i++)
			{
			if(iNr==iHostNr[i])break;
			}

		if(i<iCount)
			{
			iCount--;
			continue;
			}

		iHostNr[iCount]=iNr;
		iPos=strcspn(pWhoIamHosts[iNr],"/");
		memcpy(cHostname,pWhoIamHosts[iNr],iPos);
		cHostname[iPos]=0;

		if(sConnection.Connect(cHostname))		// Eine Verbindung zum Server aufbauen
			{
			continue;
			}

			pFilename=pWhoIamHosts[iNr]+iPos+1;
		if(*pFilename==0)pFilename="/";

		sConnection.Get(pFilename);				// Die HTML Datei einlesen
		iLen=sConnection.DataLength();

		if(iLen<=0)continue;

			pHtmlData=sConnection.Data();		// Zeiger auf Daten holen
		if(!pHtmlData)continue;

		iFound=0;
		iHostNr[iCount]=iNr;
		cHostIp[iCount][0]=0;

		for(i=0,iLast=0;i<iLen-7;i++)			// Suche eine IP-Adresse
			{
			iNext = (pHtmlData[i]>='0' && pHtmlData[i]<='9')? 1:0;

			if(!iLast && iNext)
			do	{
				for(iPos=i+1;iPos<i+3;iPos++)
					{
					if(pHtmlData[iPos]<'0')break;
					if(pHtmlData[iPos]>'9')break;
					}

				if(pHtmlData[iPos]!='.')break;

				j=iPos;

				for(iPos=j+1;iPos<j+4;iPos++)
					{
					if(pHtmlData[iPos]<'0')break;
					if(pHtmlData[iPos]>'9')break;
					}

				if(pHtmlData[iPos]!='.')break;

				j=iPos;

				for(iPos=j+1;iPos<j+4;iPos++)
					{
					if(pHtmlData[iPos]<'0')break;
					if(pHtmlData[iPos]>'9')break;
					}

				if(pHtmlData[iPos]!='.')break;

				j=iPos;

				for(iPos=j+1;iPos<j+4;iPos++)
					{
					if(pHtmlData[iPos]<'0')break;
					if(pHtmlData[iPos]>'9')break;
					}

				if(pHtmlData[iPos]>='0')
				if(pHtmlData[iPos]<='9')break;
				if(pHtmlData[iPos]>='A')
				if(pHtmlData[iPos]<='Z')break;
				if(pHtmlData[iPos]>='a')
				if(pHtmlData[iPos]<='z')break;
				if(pHtmlData[iPos]=='.')break;

				memcpy(cHostIp[iOkCount],pHtmlData+i,iPos-i);
				cHostIp[iOkCount][iPos-i]=0;
				iOkCount++;
				iFound=1;
				}while(0);

			if(iFound)break;
			iLast = iNext;
			}

		if(iOkCount>=iHostsMin)				// Zhle ob genug Server da sind
		for(i=0;i<iOkCount;i++)
			{
			iFound=1;
			for(j=i+1;j<iOkCount;j++)
				{
				if(!strcmp(cHostIp[i],cHostIp[j]))iFound++;
				if(iFound>=iHostsMin)
					{
					strcpy(cCurrentIp,cHostIp[j]);
					iCurrentTime=time(0);
					return cCurrentIp;
					}
				}
			}
		}


return 0;
}

//*****************************************************************************
//*
//*		main
//*
//*****************************************************************************
int main()
{
const char	*pIpAddr;


		pIpAddr=GetWanIp();
	if(!pIpAddr)
		{
		printf("\nDie IP-Adresse konnte nicht bestimmt werden !\n");
		}
	else{
		printf("\nDie IP-Adresse ist: %s\n",pIpAddr);
		}



	getch();


return 0;
}
